/*
 * insert_test.c
 *
 * Actually, a select-then-insert test.  
 *
 *  Copyright 1993 Buzz Moschetti
 * 
 *  Permission to use, copy, modify, distribute, and sell this software
 *  and its documentation for any purpose is hereby granted by Buzz
 *  Moschetti (the "Author") without fee, provided that the above
 *  copyright notice appear in all copies and that both that copyright
 *  notice and this permission notice appear in supporting documentation,
 *  and that the name of the Author. or contractions or abbreviations of
 *  the same not be used in advertising or publicity pertaining to
 *  distribution of the software without prior specific, written
 *  permission.  The Author does not make any representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 *
 *  THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 *  SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS, IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 *  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 *  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
 *  CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 *  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
 
#include <dsql.h>


int
main()
{
      Q_db_handle db, db2;
      Q_tx_handle tx;
      long status[20];

      QField ptrs[4];
      char buf[255];

      int rc;
      struct tm t;

      Query q, q2;

      char *sql = "select LNAME, FNAME, MDATE, AMOUNT from tester";




      /*
       *  Create the template area: 
       */
      (void) q_init();

      /*
       *  Open some DBs:
       */
      (void) q_open_db(status, &db, "Test.gdb");
      (void) q_open_db(status, &db2, "Test2.gdb");

      (void) q_start_trans(status, &tx, 2, db, 0, db2, 0);


      (void) q_gen(status, &q, sql, db, tx);


      (void) q_open_cursor(status, &q, tx);


      while((rc = q_fetch(status, &q, ptrs)) != Q_EOC) {

	    if(rc) {
		  (void) printf("fetch failed!\n");
		  exit(1);
	    }
	    
	    t = Q_TMV(&ptrs[2]);

	    (void) sprintf(buf,
		"insert into tester (LNAME, FNAME, MDATE, AMOUNT) \
		values \
		('%s', '%s', '%d/%d/%d', %lf)",
			   Q_CPV(&ptrs[0]),
			   Q_CPV(&ptrs[1]),
			   t.tm_mon + 1,
			   t.tm_mday,
			   t.tm_year + 1900,
			   Q_DBLV(&ptrs[3]));
	    
	    (void) q_gen(status, &q2, buf, db2, tx);

	    if(q_execute(status, &q2, tx)) {
		  (void) printf("didn't insert...\n");
	    } else {
		  (void) printf("Insert OK.\n");
	    }		  
      }


      (void) q_commit_trans(status, &tx);
	    
      (void) q_close_db(status, &db);
      (void) q_close_db(status, &db2);


      return 0;
}






