#!interperl

#
#  insert_test.perl
#
#  Actually, a select-then-insert test.  
#
#  Copyright 1993 Buzz Moschetti
#
#  Permission to use, copy, modify, distribute, and sell this software
#  and its documentation for any purpose is hereby granted by Buzz
#  Moschetti (the "Author") without fee, provided that the above
#  copyright notice appear in all copies and that both that copyright
#  notice and this permission notice appear in supporting documentation,
#  and that the name of the Author. or contractions or abbreviations of
#  the same not be used in advertising or publicity pertaining to
#  distribution of the software without prior specific, written
#  permission.  The Author does not make any representations about the
#  suitability of this software for any purpose.  It is provided "as is"
#  without express or implied warranty.
#
#  THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
#  SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
#  FITNESS, IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
#  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
#  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
#  CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
#  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#


$dba = "Test.gdb";
$dbb = "Test2.gdb";

$db1 = &dbready($dba) || &fatal_dberr("Error attaching " . $dba);
$db2 = &dbready($dbb) || &fatal_dberr("Error attaching " . $dbb);

$tx = &dbstarttrans($db1, 0, $db2, 0) || &fatal_dberr("Error starting tx");


$q1 = &dbprepare("select LNAME, FNAME, MDATE, AMOUNT from tester",$db1, $tx) || 
	&fatal_dberr("Error preparing select statement");
	
&dbopencursor($q1, $tx) || &fatal_dberr("Error opening cursor");


while(@rec = &dbfetchrow($q1)) {

	printf "Add {$rec[0], $rec[1], $rec[2], $rec[3]}\n";

	$q2 = &dbprepare("insert into tester
		(LNAME, FNAME, MDATE, AMOUNT)
		values
		('$rec[0]', '$rec[1]', '$rec[2]', $rec[3])",
		$db2, $tx) || &fatal_dberr("Error preparing insert statement");

	&dbexecute($q2, $tx) || &fatal_dberr("Error executing statement.");
}


&dbcommit($tx) || &fatal_dberr("Error committing work");

&dbfinish($db1) || &fatal_dberr("Error detaching DB 1");
&dbfinish($db2) || &fatal_dberr("Error detaching DB 2");



sub fatal_dberr {
	local($msg) = @_;	# local copy parameters

	print "$msg\n";

	@errtxt = &dberrtxt;

	foreach $msg (@errtxt) {
		print "$msg \n";
	}

	&dbrollback($tx) || &fatal_dberr("Error rolling back work");

	&dbfinish($db1) || &fatal_dberr("Error detaching DB 1");
	&dbfinish($db2) || &fatal_dberr("Error detaching DB 2");

	exit;
}
