/*
 * select_test.c
 *
 *  Copyright 1993 Buzz Moschetti
 * 
 *  Permission to use, copy, modify, distribute, and sell this software
 *  and its documentation for any purpose is hereby granted by Buzz
 *  Moschetti (the "Author") without fee, provided that the above
 *  copyright notice appear in all copies and that both that copyright
 *  notice and this permission notice appear in supporting documentation,
 *  and that the name of the Author. or contractions or abbreviations of
 *  the same not be used in advertising or publicity pertaining to
 *  distribution of the software without prior specific, written
 *  permission.  The Author does not make any representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 *
 *  THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 *  SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS, IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 *  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 *  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
 *  CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 *  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
 
#include <dsql.h>


int
main(argc, argv)
int argc;
char **argv;
{
      Q_db_handle db;
      Q_tx_handle tx;
      long status[20];

      QField ptrs[16];
      char buf[255];

      int rc;

      Query q;

      char *sql = "SELECT * FROM TESTER";



      /*
       *  Create the template area: 
       */
      (void) q_init();

      /*
       *  Open some DBs:
       */
      (void) q_open_db(status, &db, argv[1]);

      (void) q_start_trans(status, &tx, 1, db, 0);


      (void) q_gen(status, &q, sql, db, tx);
      
      (void) q_open_cursor(status, &q, tx);


      while((rc = q_fetch(status, &q, ptrs)) != -2) {

	    switch(rc) {
		case 0:
		  for(rc = 0; rc < Q_NUMCOLS(&q); rc++) {
			if(Q_FTYPE(&ptrs[rc]) == DATE_TYPE) {
			      (void) q_format_fld(buf, "%m/%d/%Y", &ptrs[rc]);
			} else {
			      (void) q_format_fld(buf, 0, &ptrs[rc]);
			}

			(void) printf("%s|", buf);
		  }
		  (void) printf("\n");
		  break;

		default:
		  (void) printf("error fetching data!\n");
		  (void) q_error_text(status, buf, "|");
		  (void) printf("error: %s\n", buf);
		  break;
	    }
      }
      
      (void) q_close_cursor(status, &q);

      (void) q_commit_trans(status, &tx);
	    
      (void) q_close_db(status, &db);



      return 0;
}






