#!interperl

#
#  Simple select tester.
#
#  Copyright 1993 Buzz Moschetti
#
#  Permission to use, copy, modify, distribute, and sell this software
#  and its documentation for any purpose is hereby granted by Buzz
#  Moschetti (the "Author") without fee, provided that the above
#  copyright notice appear in all copies and that both that copyright
#  notice and this permission notice appear in supporting documentation,
#  and that the name of the Author. or contractions or abbreviations of
#  the same not be used in advertising or publicity pertaining to
#  distribution of the software without prior specific, written
#  permission.  The Author does not make any representations about the
#  suitability of this software for any purpose.  It is provided "as is"
#  without express or implied warranty.
#
#  THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
#  SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
#  FITNESS, IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
#  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
#  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
#  CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
#  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
# 

$db = "Test.gdb";

$db1 = &dbready($db) || &fatal_dberr("Error attaching " . $db);

$tx = &dbstarttrans($db1, 0) || &fatal_dberr("Error starting tx");


$q1 = &dbprepare("select LNAME, FNAME, MDATE, AMOUNT from tester",$db1, $tx) || 
	&fatal_dberr("Error preparing statement");
	

&dbopencursor($q1, $tx) || &fatal_dberr("Error opening cursor");


while(@rec = &dbfetchrow($q1)) {
	printf "@rec\n";
}

&dbclosecursor($q1) || &fatal_dberr("Error closing cursor");


&dbcommit($tx) || &fatal_dberr("Error committing work");

&dbfinish($db1) || &fatal_dberr("Error detaching DB");



sub fatal_dberr {
	local($msg) = @_;	# local copy parameters

	print "$msg\n";

	@errtxt = &dberrtxt;

	foreach $msg (@errtxt) {
		print "$msg \n";
	}
	exit;
}
